import java.awt.*;
import java.applet.Applet;


class ColorButton extends Canvas {

  protected int WIDTH = 12;
  protected int HEIGHT = 12;
  public int color=0;
  public boolean mode=false;
  static ColorButton lastbutton=null;
  UserMode user;
  
public ColorButton(UserMode u,int c) {
  super();
  color=c;
  user=u;
}

public void addNotify() {
  super.addNotify();
  resize(WIDTH, HEIGHT);
}

public void paint(Graphics g) {
  Dimension d = this.size();
  g.setColor(ColorSet.colors[color]);
  g.fillRect(0,0,d.width-1, d.height-1);
  g.setColor(Color.lightGray);
  g.draw3DRect(0, 0, d.width - 1, d.height - 1, !mode);
}

public void update(Graphics g) {
  paint(g);
}

public void pushButton() {
  if (lastbutton!=null) {
    lastbutton.mode=false;
    lastbutton.repaint();
  }
  lastbutton=this;
  if (color < 0 ) color+=256;
  user.color=color;
  mode=true;
  repaint();
}

public boolean mouseDown(Event evt, int x, int y) {
  pushButton();
  return true;
}


}  

public class ColorPanel extends Panel {

  final String buttons[]={"pencil","brush","line","poly","rect","oval",
			  "circle","fill","capt","mode"};

  UserMode user;
  ColorButton blist[]=new ColorButton[ColorSet.NumberColors];
  int CBX=12, CBY=12, SBX=2, SBY=2;


public ColorPanel(UserMode u) {
  super();
  user=u;
}

protected void makebutton(int x, int y, int c) {
  blist[c] = new ColorButton(user,c);
  add(blist[c]);
}

public void remotePush (int setColor ) {
	blist[setColor].pushButton();	
}


public void addNotify() {
  super.addNotify();
  //  resize((ColorSet.colors.length/2+1) * (CBX+SBX) + SBX, (CBY+SBY)*2 + SBY);

  for (int i=0; i < 2; i++) {
    makebutton(i/7*(CBX+SBX)+SBX, (i%7)*(CBY+SBY)+SBY,i);
  }
  blist[1].pushButton();
}


}
