import java.awt.*;
import java.awt.image.*;


public class TileIcon extends Panel {

  protected int WIDTH = 32;
  protected int HEIGHT = 32;
  protected int BORDER = 7;
  UserMode user;
  Graphics canvas;
  int topIcon=0, listsize=1;
  Dimension d;

public TileIcon(UserMode u) {
  super();
  user=u;
  setLayout(null);
}


public void addNotify() {
  super.addNotify();
  canvas=getGraphics();
  reset();
}

public void reset() {
  WIDTH=user.IconWidth;
  HEIGHT=user.IconHeight;
  topIcon=0;
  repaint();
}

public void putIcon() {
  putIcon(user.currIcon);
}

public void putIcon(int i) {
  if (i >= topIcon && i<=topIcon+listsize) {
    canvas.setColor(Color.lightGray);
    int y=(HEIGHT+BORDER)*(i-topIcon)+BORDER;
    if (i < user.IconNum) {
      canvas.draw3DRect(BORDER-1, y-1, WIDTH + 2, HEIGHT+2, 
			i==user.currIcon? false : true);
      Image image = this.createImage
	(new MemoryImageSource(WIDTH,HEIGHT,
			       ColorSet.opaquemodel,
			       user.Icons[i],
			       0,WIDTH));
      canvas.drawImage(image,BORDER,y,null);
    }
    else
      canvas.fillRect(BORDER-1, y-1, WIDTH + 3, HEIGHT+3);
  }
}


public void paint(Graphics g) {
  d = this.size();
  listsize=1;
  for (int i=topIcon; i<topIcon+listsize; i++)
    putIcon(i);
}

public void shift(boolean dir) {
  if (dir) {
    topIcon-=listsize;
    if (topIcon < 0) 
      topIcon=0;
    paint(canvas);
  }
  else {
    if (topIcon+listsize < user.IconNum) {
      topIcon+=listsize;
      if (topIcon < 0) 
	topIcon=0;
      paint(canvas);
    }
  }
}

public boolean mouseDown(Event evt, int x, int y) {
  int i=(y-BORDER)/(BORDER+HEIGHT)+topIcon;
  if (x > BORDER && (x <BORDER+WIDTH) &&
      y > BORDER && ((y-BORDER)%(HEIGHT+BORDER)) < HEIGHT
      && user.currIcon != i && i < listsize+topIcon && i >=topIcon
      && i < user.IconNum) {
    int last=user.currIcon;
    user.resync(i);
    putIcon(last);
    return true;
  }
return false;
}

public Dimension preferredSize() {
  return(new Dimension(WIDTH +BORDER*2, HEIGHT +BORDER*2));
}

public Dimension minimumSize() {
  return(new Dimension(WIDTH + BORDER*2, HEIGHT + BORDER*2));
}

}  
