

public class UserMode {
  public TileIcon tileicon=null;
  public TilePanel tilepanel=null;
  public int mode=1,color=0;
  public boolean newmode=true,fillmode=false, pastemode=false,
    captmode=false;

  public int firstx, firsty;
  public int captx1, capty1, captx2, capty2;
  public IconBuf clipboard=null,undobuf=null;

  public int magni=9, currIcon=0;
  public int IconWidth=32, IconHeight=32, IconNum=1;
  public byte Icons[][];

public UserMode() {
  newTiles(32,32,1,true);
}

public void newTiles(int w, int h, int n, boolean init) {
  IconNum=n;
  IconWidth=w;
  IconHeight=h;
  Icons=new byte[IconNum][IconWidth*IconHeight];
  if (init) {
    for (int i = 0 ; i < IconNum ; i++) {
      int index=0;
      for (int k = 0 ; k < IconWidth ; k++) 
	for (int j = 0 ; j < IconHeight ; j++) 
	  Icons[i][index++]=0;
    }
  }
}

public void clearIcon() {
  for (int i=0;i<IconWidth*IconHeight;i++) Icons[currIcon][i] = 0;
}
  
  
public void resize(int w, int h, int n) {
  int j,k;
  int oldw=IconWidth,oldh=IconHeight, oldn=IconNum;
  byte temp[][]=Icons;
  newTiles(w,h,n,false);
  for (int i = 0 ; i < oldn && i < n; i++) {
    for (int y=0; y < oldh && y < h; y++) {
      j=y*oldw;
      k=y*w;
      for (int x=0; x < oldw && x < w; x++) {
	Icons[i][k]=temp[i][j];
	k++; j++;
      }
    }
  }
}
     
public void reset() {
  currIcon=0;
  pastemode=false;
  undobuf=null;
  newmode=true;
  captmode=false;
  if (tileicon!=null) {
    tileicon.reset();
    tilepanel.reset();
  }
  resync(0);
}

public void resync(int i) {
  currIcon=i;
  pastemode=false;
  undobuf=null;
  newmode=true;
  captmode=false;
  if (tilepanel!=null) {
    tilepanel.resync();
    tileicon.putIcon();
  }
}
}
