import java.awt.*;
import java.applet.*;
import java.awt.image.MemoryImageSource;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.IOException;

class ImageButton extends Button {
   Image buttonimg;
   int buttonMode;
   UserMode user;
   
   ImageButton(UserMode u, int Mode, byte[] byteimage, int w, int h) {
     user = u;
     buttonMode = Mode;
     buttonimg = this.createImage
            (new MemoryImageSource(w,h,
			       ColorSet.model,
			       byteimage,
			       0,w));
   }//end CONSTRUCTOR ImageButton          
   
   public void paint(Graphics g) {
     super.paint(g);
     g.drawImage(buttonimg,3,3,null);
   }//end paint

   public void addNotify() {
    super.addNotify();
   }

    public boolean action(Event evt, Object obj) {
      user.mode = buttonMode+1;
      user.newmode = true;
      super.repaint(); // XXX
      repaint();
    return true;
   }

}//end CLASS ImageButton     

public class UtilPanel extends Panel {
  final ImageButton button[] = new ImageButton[12];
  UserMode user;
  int CBX=32, CBY=32, SBX=5, SBY=5;

public UtilPanel(UserMode u) {
  super();
  user=u;
}

public void update(Graphics g) {
  paint(g);
}

public void paint(Graphics g) {
  for (int i=0; i<12; i++) {
    button[i].repaint();
  }
}

private void makebuttons(String filename) {
  int type, state=0, len=0, index=0, w=0,h=0,n=0;
  InputStream is = null;
       
  try {
    is = new FileInputStream(filename);
  } catch(Throwable e) {
    System.out.println("Can't open \""+filename+"\"");
    System.exit(1);
  }
  try {
    
    byte setupVars[] = new byte[3];
    
    is.read(setupVars);
    
    w=setupVars[0];
    h=setupVars[1];
    n=setupVars[2];
    
    len=w*h;
    byte[][] byteimage= new byte[n][len];
    
    
    for (int i=0;i<n;i++) 
      {
      is.read(byteimage[i]);
      button[i] = new ImageButton(user, i, byteimage[i], CBX, CBY);
      add(button[i]);
      button[i].resize(CBX+6, CBY+6);
      button[i].move((i%2)*(CBX+SBX)+SBX,i/2*(CBY+SBY)+SBY);
      }
    
    is.close();
  } catch(IOException e) {
    System.out.println("Can't read \""+filename+"\"");
    System.exit(1);
  }
  
}

public void addNotify() {
  super.addNotify();
  resize((CBX+SBX)*2+SBX, (button.length/2+1) * (CBY+SBY) + SBY);

  setLayout(null);
  
  this.makebuttons("UtilButton.img");  
  
}

public Dimension preferredSize() {
  return(new Dimension ((CBX+SBX)*2 + SBX,
			(button.length/2+1) * (CBY+SBY) + SBY));
}

public Dimension minimumSize() {
  return(new Dimension ((CBX+SBX)*2 + SBX,
			(button.length/2+1) * (CBY+SBY) + SBY));

}


}
